grammar debugMeWithAntlrWorks;
 options{backtrack=true; memoize=true;} 



parse :
	 result=ruleModel
	 // Always return the root node! This prevents that this method is called multiple times
	 // with interesting side effects.
	 EOF
;

ruleModel 

:
((ruleFeatureImport)

(ruleCoreModelImport)

(ruleConcern)*

(ruleVariantOrdering)?
)
;

ruleFeatureImport 

:
(('import')

('features')

('<')

( RULE_STRING
)

('>')

(';')
)
;

ruleFeature 

:
(('feature')

(RULE_ID)
)
;

ruleCoreModelImport 

:
(('import')

('core')

('<')

( RULE_STRING
)

('>')

(';')
)
;

ruleConcern 

:
(('concern')

(RULE_ID)

('{')

(ruleConcernElement)+

('}')
)
;

ruleConcernElement 
:
        temp_concern=ruleConcern 	|        temp_variant=ruleVariant 	|        temp_pointcut=rulePointCut 	;

ruleVarColElm 

:
(RULE_ID
)
;

ruleVariant 

:
(('variant')

(RULE_ID)?

('for')

(ruleFeatureExpression)

('{')

((ruleAction)

(';')
)+

('}')
)
;

ruleVariantOrdering 

:
(('order')

(ruleVarOrderPair)

((',')

(ruleVarOrderPair)
)*

(';')
)
;

ruleVarOrderPair 

:
(('(')

(RULE_ID
)

(',')

(RULE_ID
)

(')')
)
;

ruleFeatureExpression 
:
        temp_featureexpatom=ruleFeatureExpAtom 	|        temp_featureorexp=ruleFeatureOrExp 	|        temp_featureandexp=ruleFeatureAndExp 	|        temp_featurenotexp=ruleFeatureNotExp 	;

ruleFeatureExpAtom 

:
((RULE_ID
)
	|
(('{')

(RULE_STRING)

('}')
)
)
;

ruleFeatureOrExp 

:
(('or')

('(')

(ruleFeatureExpression)

((',')

(ruleFeatureExpression)
)+

(')')
)
;

ruleFeatureAndExp 

:
(('and')

('(')

(ruleFeatureExpression)

((',')

(ruleFeatureExpression)
)+

(')')
)
;

ruleFeatureNotExp 

:
(('not')

('(')

(ruleFeatureExpression)

(')')
)
;

rulePointCut 

:
(('pointcut')

(RULE_ID)

('{')

(rulePointCutExpression)

('}')
)
;

rulePointCutReference 

:
(('pcref')

(RULE_ID
)
)
;

rulePointCutExpression 
:
        temp_pcdesignator=rulePCDesignator 	|        temp_pceoperator=rulePCEOperator 	;

rulePCDesignator 

:
(RULE_STRING)
;

rulePCEOperator 
:
        temp_pceandoperator=rulePCEAndOperator 	|        temp_pceoroperator=rulePCEOrOperator 	;

rulePCEAndOperator 

:
(('and')

('(')

(rulePointCutExpression)

((',')

(rulePointCutExpression)
)+

(')')
)
;

rulePCEOrOperator 

:
(('or')

('(')

(rulePointCutExpression)

((',')

(rulePointCutExpression)
)+

(')')
)
;

ruleElementReference 
:
        temp_pointcutexpression=rulePointCutExpression 	|        temp_pointcutreference=rulePointCutReference 	;

ruleAction 
:
        temp_connectaction=ruleConnectAction 	|        temp_removeaction=ruleRemoveAction 	|        temp_createpackageaction=ruleCreatePackageAction 	|        temp_createcomponentinstanceaction=ruleCreateComponentInstanceAction 	|        temp_setdefaultliteralattributeaction=ruleSetDefaultLiteralAttributeAction 	|        temp_setdefaultattributeaction=ruleSetDefaultAttributeAction 	|        temp_setliteralattributeaction=ruleSetLiteralAttributeAction 	|        temp_setattributeaction=ruleSetAttributeAction 	|        temp_mergeaction=ruleMergeAction 	|        temp_createconnectoraction=ruleCreateConnectorAction 	|        temp_connectportsaction=ruleConnectPortsAction 	;

ruleConnectAction 

:
(('connect')

('(')

(ruleElementReference)

(',')

(ruleElementReference)

(',')

(ruleElementReference)

(')')
)
;

ruleRemoveAction 

:
(('remove')

('(')

(ruleElementReference)

(')')
)
;

ruleCreatePackageAction 

:
(('createPackage')

('(')

(ruleElementReference)

(',')

(ruleElementReference)

(')')
)
;

ruleCreateComponentInstanceAction 

:
(('createComponentInstance')

('(')

(ruleElementReference)

(',')

(ruleElementReference)

(')')
)
;

ruleSetDefaultLiteralAttributeAction 

:
(('setDefaultLiteralAttribute')

('(')

(ruleElementReference)

(',')

(ruleElementReference)

(')')
)
;

ruleSetDefaultAttributeAction 

:
(('setDefaultAttribute')

('(')

(ruleElementReference)

(',')

(ruleElementReference)

(')')
)
;

ruleSetLiteralAttributeAction 

:
(('setLiteralAttribute')

('(')

(ruleElementReference)

(',')

(ruleElementReference)

(',')

(ruleElementReference)

(')')
)
;

ruleSetAttributeAction 

:
(('setAttribute')

('(')

(ruleElementReference)

(',')

(ruleElementReference)

(',')

(ruleElementReference)

(')')
)
;

ruleMergeAction 

:
(('merge')

('(')

(ruleElementReference)

(',')

(ruleElementReference)

(')')
)
;

ruleCreateConnectorAction 

:
(('createConnector')

('(')

(ruleElementReference)

(',')

(ruleElementReference)

(',')

(ruleElementReference)

(',')

(ruleElementReference)

(',')

(ruleElementReference)

(')')
)
;

ruleConnectPortsAction 

:
(('connectPorts')

('(')

(ruleElementReference)

(',')

(ruleElementReference)

(',')

(ruleElementReference)

(',')

(ruleElementReference)

(',')

(ruleElementReference)

(',')

(ruleElementReference)

(')')
)
;

RULE_ID :

	 ('^')?('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*
	 
;

RULE_STRING :

	 '\"' ( '\\' ('b'|'t'|'n'|'f'|'r'|'\"'|'\''|'\\') | ~('\\'|'\"') )* '\"' |
	 '\'' ( '\\' ('b'|'t'|'n'|'f'|'r'|'\"'|'\''|'\\') | ~('\\'|'\'') )* '\''
	 
;

RULE_INT :

	 ('-')?('0'..'9')+
	 
;

RULE_WS :

	 (' '|'\t'|'\r'|'\n')+ {$channel=HIDDEN;}
	 
;

RULE_ML_COMMENT :

	 '/*' ( options {greedy=false;} : . )* '*/' {$channel=HIDDEN;}
	 
;

RULE_SL_COMMENT :

	 '//' ~('\n'|'\r')* '\r'? '\n' {$channel=HIDDEN;}
	 
;

