grammar debugMeWithAntlrWorks;
 options{backtrack=true; memoize=true;} 



parse :
	 result=ruleModel
	 // Always return the root node! This prevents that this method is called multiple times
	 // with interesting side effects.
	 EOF
;

ruleModel 

:
((ruleFeatureImport)

(ruleCoreModelImport)

(('atf')

(RULE_STRING)
)?

(ruleConcern)*

(ruleVariantOrdering)?
)
;

ruleFeatureImport 

:
(('import')

('features')

('<')

( RULE_STRING
)

('>')

(';')
)
;

ruleFeature 

:
(('feature')

(RULE_ID)
)
;

ruleCoreModelImport 

:
(('import')

('core')

('<')

( RULE_STRING
)

('>')

(';')
)
;

ruleConcern 

:
(('concern')

(RULE_ID)

('{')

(ruleConcernElement)+

('}')
)
;

ruleConcernElement 
:
        temp_concern=ruleConcern 	|        temp_variant=ruleVariant 	|        temp_pointcut=rulePointCut 	;

ruleVarColElm 

:
(RULE_ID
)
;

ruleVariant 

:
(('variant')

(RULE_ID)?

('for')

(ruleFeatureExpression)

('{')

((ruleAction)

(';')
)+

('}')
)
;

ruleVariantOrdering 

:
(('order')

(ruleVarOrderPair)

((',')

(ruleVarOrderPair)
)*

(';')
)
;

ruleVarOrderPair 

:
(('(')

(RULE_ID
)

(',')

(RULE_ID
)

(')')
)
;

ruleFeatureExpression 
:
        temp_featureexpatom=ruleFeatureExpAtom 	|        temp_featureorexp=ruleFeatureOrExp 	|        temp_featureandexp=ruleFeatureAndExp 	|        temp_featurenotexp=ruleFeatureNotExp 	;

ruleFeatureExpAtom 

:
((RULE_ID
)
	|
(('{')

(RULE_STRING)

('}')
)
)
;

ruleFeatureOrExp 

:
(('or')

('(')

(ruleFeatureExpression)

((',')

(ruleFeatureExpression)
)+

(')')
)
;

ruleFeatureAndExp 

:
(('and')

('(')

(ruleFeatureExpression)

((',')

(ruleFeatureExpression)
)+

(')')
)
;

ruleFeatureNotExp 

:
(('not')

('(')

(ruleFeatureExpression)

(')')
)
;

rulePointCut 

:
(('pointcut')

(RULE_ID)

('{')

(rulePointCutExpression)

('}')
)
;

rulePointCutReference 

:
(('pcref')

(RULE_ID
)
)
;

rulePointCutExpression 
:
        temp_pcdesignator=rulePCDesignator 	|        temp_pceoperator=rulePCEOperator 	;

rulePCDesignator 

:
(RULE_STRING)
;

rulePCEOperator 
:
        temp_pceandoperator=rulePCEAndOperator 	|        temp_pceoroperator=rulePCEOrOperator 	;

rulePCEAndOperator 

:
(('and')

('(')

(rulePointCutExpression)

((',')

(rulePointCutExpression)
)+

(')')
)
;

rulePCEOrOperator 

:
(('or')

('(')

(rulePointCutExpression)

((',')

(rulePointCutExpression)
)+

(')')
)
;

ruleElementReference 
:
        temp_pointcutexpression=rulePointCutExpression 	|        temp_pointcutreference=rulePointCutReference 	;

ruleAction 
:
        temp_traceaction=ruleTraceAction 	|        temp_createincludeaction=ruleCreateIncludeAction 	|        temp_createextendsaction=ruleCreateExtendsAction 	|        temp_createinheritsaction=ruleCreateInheritsAction 	|        temp_createassociationaction=ruleCreateAssociationAction 	|        temp_insertusecaseaction=ruleInsertUseCaseAction 	|        temp_insertactoraction=ruleInsertActorAction 	|        temp_insertpackageaction=ruleInsertPackageAction 	|        temp_removeusecaseaction=ruleRemoveUseCaseAction 	|        temp_removeactoraction=ruleRemoveActorAction 	|        temp_removepackageaction=ruleRemovePackageAction 	|        temp_removeelementaction=ruleRemoveElementAction 	|        temp_removeactionaction=ruleRemoveActionAction 	|        temp_removeobjectactionaction=ruleRemoveObjectActionAction 	|        temp_createactionaction=ruleCreateActionAction 	|        temp_createobjectactionaction=ruleCreateObjectActionAction 	|        temp_createactivityparameteraction=ruleCreateActivityParameterAction 	|        temp_createoutputpinaction=ruleCreateOutputPinAction 	|        temp_createdecisionnodeaction=ruleCreateDecisionNodeAction 	|        temp_connectactionsaction=ruleConnectActionsAction 	|        temp_connectpinsaction=ruleConnectPinsAction 	|        temp_connectactionswithguardaction=ruleConnectActionsWithGuardAction 	|        temp_connectactivityelementsaction=ruleConnectActivityElementsAction 	|        temp_replaceactionbyactivityaction=ruleReplaceActionByActivityAction 	|        temp_createactivitymodelaction=ruleCreateActivityModelAction 	|        temp_removeactivitymodelaction=ruleRemoveActivityModelAction 	|        temp_connectactionwithinitialnodeaction=ruleConnectActionWithInitialNodeAction 	|        temp_connectactionwithfinalnodeaction=ruleConnectActionWithFinalNodeAction 	;

ruleTraceAction 

:
(('trace')

('(')

(ruleElementReference)

(')')
)
;

ruleCreateIncludeAction 

:
(('createInclude')

('(')

(ruleElementReference)

(',')

(ruleElementReference)

(')')
)
;

ruleCreateExtendsAction 

:
(('createExtends')

('(')

(ruleElementReference)

(',')

(ruleElementReference)

(')')
)
;

ruleCreateInheritsAction 

:
(('createInherits')

('(')

(ruleElementReference)

(',')

(ruleElementReference)

(')')
)
;

ruleCreateAssociationAction 

:
(('createAssociation')

('(')

(ruleElementReference)

(',')

(ruleElementReference)

(')')
)
;

ruleInsertUseCaseAction 

:
(('insertUseCase')

('(')

(ruleElementReference)

(',')

(ruleElementReference)

(')')
)
;

ruleInsertActorAction 

:
(('insertActor')

('(')

(ruleElementReference)

(',')

(ruleElementReference)

(')')
)
;

ruleInsertPackageAction 

:
(('insertPackage')

('(')

(ruleElementReference)

(',')

(ruleElementReference)

(')')
)
;

ruleRemoveUseCaseAction 

:
(('removeUseCase')

('(')

(ruleElementReference)

(')')
)
;

ruleRemoveActorAction 

:
(('removeActor')

('(')

(ruleElementReference)

(')')
)
;

ruleRemovePackageAction 

:
(('removePackage')

('(')

(ruleElementReference)

(')')
)
;

ruleRemoveElementAction 

:
(('removeElement')

('(')

(ruleElementReference)

(')')
)
;

ruleRemoveActionAction 

:
(('removeAction')

('(')

(ruleElementReference)

(')')
)
;

ruleRemoveObjectActionAction 

:
(('removeObjectAction')

('(')

(ruleElementReference)

(')')
)
;

ruleCreateActionAction 

:
(('createAction')

('(')

(ruleElementReference)

(',')

(ruleElementReference)

(')')
)
;

ruleCreateObjectActionAction 

:
(('createObjectAction')

('(')

(ruleElementReference)

(',')

(ruleElementReference)

(')')
)
;

ruleCreateActivityParameterAction 

:
(('createActivityParameter')

('(')

(ruleElementReference)

(',')

(ruleElementReference)

(')')
)
;

ruleCreateOutputPinAction 

:
(('createOutputPin')

('(')

(ruleElementReference)

(',')

(ruleElementReference)

(')')
)
;

ruleCreateDecisionNodeAction 

:
(('createDecisionNode')

('(')

(ruleElementReference)

(',')

(ruleElementReference)

(')')
)
;

ruleConnectActionsAction 

:
(('connectActions')

('(')

(ruleElementReference)

(',')

(ruleElementReference)

(')')
)
;

ruleConnectPinsAction 

:
(('connectPins')

('(')

(ruleElementReference)

(',')

(ruleElementReference)

(',')

(ruleElementReference)

(',')

(ruleElementReference)

(')')
)
;

ruleConnectActionsWithGuardAction 

:
(('connectActionsWithGuard')

('(')

(ruleElementReference)

(',')

(ruleElementReference)

(',')

(ruleElementReference)

(')')
)
;

ruleConnectActivityElementsAction 

:
(('connectActivityElements')

('(')

(ruleElementReference)

(',')

(ruleElementReference)

(',')

(ruleElementReference)

(')')
)
;

ruleReplaceActionByActivityAction 

:
(('replaceActionByActivity')

('(')

(ruleElementReference)

(',')

(ruleElementReference)

(')')
)
;

ruleCreateActivityModelAction 

:
(('createActivityModel')

('(')

(ruleElementReference)

(',')

(ruleElementReference)

(')')
)
;

ruleRemoveActivityModelAction 

:
(('removeActivityModel')

('(')

(ruleElementReference)

(')')
)
;

ruleConnectActionWithInitialNodeAction 

:
(('connectActionWithInitialNode')

('(')

(ruleElementReference)

(',')

(ruleElementReference)

(')')
)
;

ruleConnectActionWithFinalNodeAction 

:
(('connectActionWithFinalNode')

('(')

(ruleElementReference)

(',')

(ruleElementReference)

(')')
)
;

RULE_ID :

	 ('^')?('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*
	 
;

RULE_STRING :

	 '\"' ( '\\' ('b'|'t'|'n'|'f'|'r'|'\"'|'\''|'\\') | ~('\\'|'\"') )* '\"' |
	 '\'' ( '\\' ('b'|'t'|'n'|'f'|'r'|'\"'|'\''|'\\') | ~('\\'|'\'') )* '\''
	 
;

RULE_INT :

	 ('-')?('0'..'9')+
	 
;

RULE_WS :

	 (' '|'\t'|'\r'|'\n')+ {$channel=HIDDEN;}
	 
;

RULE_ML_COMMENT :

	 '/*' ( options {greedy=false;} : . )* '*/' {$channel=HIDDEN;}
	 
;

RULE_SL_COMMENT :

	 '//' ~('\n'|'\r')* '\r'? '\n' {$channel=HIDDEN;}
	 
;

