grammar vml4arch;
 options{backtrack=true; memoize=true;} 

@lexer::header {
package org.ample.vml.vml4arch.parser;

import org.openarchitectureware.xtext.parser.ErrorMsg;
import org.openarchitectureware.xtext.parser.impl.AntlrUtil;

}

@parser::header {
package org.ample.vml.vml4arch.parser;

import org.eclipse.emf.common.util.Enumerator;
import org.eclipse.emf.ecore.EObject;

import org.openarchitectureware.xtext.parser.impl.AntlrUtil;
import org.openarchitectureware.xtext.XtextFile;
import org.openarchitectureware.xtext.parser.impl.EcoreModelFactory;
import org.openarchitectureware.xtext.parser.ErrorMsg;
import org.openarchitectureware.xtext.parser.model.ParseTreeManagerNeu;
import org.openarchitectureware.xtext.parser.parsetree.Node;

import org.ample.vml.vml4arch.MetaModelRegistration;

}
@lexer::members {
	 private List<ErrorMsg> errors = new ArrayList<ErrorMsg>();
	public List<ErrorMsg> getErrors() {
		return errors;
	}

	public String getErrorMessage(RecognitionException e, String[] tokenNames) {
		String msg = super.getErrorMessage(e,tokenNames);
		errors.add(AntlrUtil.create(msg,e,tokenNames));
		return msg;
	}
}

@parser::members {

	private Token getLastToken() {
		return input.LT(-1);
	}

	protected Object convert(Object arg) {
		if (arg instanceof org.antlr.runtime.Token) {
			Token t = (Token) arg;
			String s = t.getText();
			if (t.getType() == vml4archLexer.RULE_ID && s.startsWith("^")) {
				return s.substring(1);
			} else if (t.getType()==vml4archLexer.RULE_STRING) {
				return s.substring(1,s.length()-1);
			} else if (t.getType()==vml4archLexer.RULE_INT) {
				return Integer.valueOf(s);
			}
			return s;
		}
		return arg;
	}


	private EcoreModelFactory factory = new EcoreModelFactory(MetaModelRegistration.getEPackage());
    private ParseTreeManagerNeu ptm = new ParseTreeManagerNeu();
	private XtextFile xtextfile = MetaModelRegistration.getXtextFile();
	
	{
		
	}

	public ParseTreeManagerNeu getResult() {
		return ptm;
	}

	private List<ErrorMsg> errors = new ArrayList<ErrorMsg>();
	public List<ErrorMsg> getErrors() {
		return errors;
	}

	@Override
	public void reportError(RecognitionException e) {
		String msg = super.getErrorMessage(e,tokenNames);
		errors.add(AntlrUtil.create(msg,e,tokenNames));
		ptm.addError(msg, e);
		// This doesn't work. ANTLR may simply report an superfluous token. In that case,
		// two nodes will be finished instead of one.
		// ptm.ruleFinished(null, end());
	}

    private boolean skipCurrentToken;
    
	@Override
	protected boolean recoverFromMismatchedElement(IntStream arg0, RecognitionException arg1, BitSet arg2) {
		skipCurrentToken = true;
		return super.recoverFromMismatchedElement(arg0, arg1, arg2);
	}
}


parse returns [Node r]:
	 result=ruleModel
	 // Always return the root node! This prevents that this method is called multiple times
	 // with interesting side effects.
{
if (result != null)
  ptm.setModelElement(result);
$r = ptm.getCurrent();
ptm.ruleFinished(result);}	 EOF
;

ruleModel returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "Model");
			 }
(({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(0)).eContents().get(1)).eContents().get(0)));}temp_FeatureImport=
ruleFeatureImport{if (temp_FeatureImport != null) {
  hasContent = true;
  ptm.setModelElement(temp_FeatureImport);
  factory.set($result,"features",convert(temp_FeatureImport),false);
  ptm.ruleFinished(temp_FeatureImport);
} else {
  ptm.destroyNode();
}
}
)

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(0)).eContents().get(1)).eContents().get(1)));}temp_CoreModelImport=
ruleCoreModelImport{if (temp_CoreModelImport != null) {
  hasContent = true;
  ptm.setModelElement(temp_CoreModelImport);
  factory.set($result,"coreModel",convert(temp_CoreModelImport),false);
  ptm.ruleFinished(temp_CoreModelImport);
} else {
  ptm.destroyNode();
}
}
)

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(0)).eContents().get(1)).eContents().get(2)));}temp_Concern=
ruleConcern{if (temp_Concern != null) {
  hasContent = true;
  ptm.setModelElement(temp_Concern);
  factory.add($result,"concerns",convert(temp_Concern),false);
  ptm.ruleFinished(temp_Concern);
} else {
  ptm.destroyNode();
}
}
)*

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(0)).eContents().get(1)).eContents().get(3)));}temp_VariantOrdering=
ruleVariantOrdering{if (temp_VariantOrdering != null) {
  hasContent = true;
  ptm.setModelElement(temp_VariantOrdering);
  factory.set($result,"variantOrder",convert(temp_VariantOrdering),false);
  ptm.ruleFinished(temp_VariantOrdering);
} else {
  ptm.destroyNode();
}
}
)?
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

ruleFeatureImport returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "FeatureImport");
			 }
(({skipCurrentToken = false;}'import'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(1)).eContents().get(1)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}'features'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(1)).eContents().get(1)).eContents().get(1)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}'<'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(1)).eContents().get(1)).eContents().get(2)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}
 RULE_STRING
{if (!skipCurrentToken) {
  hasContent = true;
  Token temp = getLastToken();
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(1)).eContents().get(1)).eContents().get(3)));
  factory.set($result,"fmURI",convert(temp),false);
  ptm.ruleFinished(temp);
}}
)

({skipCurrentToken = false;}'>'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(1)).eContents().get(1)).eContents().get(4)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}';'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(1)).eContents().get(1)).eContents().get(5)));
  ptm.ruleFinished(getLastToken());
}})
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

ruleFeature returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "Feature");
			 }
(({skipCurrentToken = false;}'feature'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(3)).eContents().get(1)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}
RULE_ID{if (!skipCurrentToken) {
  hasContent = true;
  Token temp = getLastToken();
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(3)).eContents().get(1)).eContents().get(1)));
  factory.set($result,"name",convert(temp),false);
  ptm.ruleFinished(temp);
}}
)
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

ruleCoreModelImport returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "CoreModelImport");
			 }
(({skipCurrentToken = false;}'import'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(4)).eContents().get(1)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}'core'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(4)).eContents().get(1)).eContents().get(1)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}'<'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(4)).eContents().get(1)).eContents().get(2)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}
 RULE_STRING
{if (!skipCurrentToken) {
  hasContent = true;
  Token temp = getLastToken();
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(4)).eContents().get(1)).eContents().get(3)));
  factory.set($result,"coreURI",convert(temp),false);
  ptm.ruleFinished(temp);
}}
)

({skipCurrentToken = false;}'>'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(4)).eContents().get(1)).eContents().get(4)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}';'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(4)).eContents().get(1)).eContents().get(5)));
  ptm.ruleFinished(getLastToken());
}})
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

ruleConcern returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "Concern");
			 }
(({skipCurrentToken = false;}'concern'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(5)).eContents().get(1)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}
RULE_ID{if (!skipCurrentToken) {
  hasContent = true;
  Token temp = getLastToken();
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(5)).eContents().get(1)).eContents().get(1)));
  factory.set($result,"name",convert(temp),false);
  ptm.ruleFinished(temp);
}}
)

({skipCurrentToken = false;}'{'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(5)).eContents().get(1)).eContents().get(2)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(5)).eContents().get(1)).eContents().get(3)));}temp_ConcernElement=
ruleConcernElement{if (temp_ConcernElement != null) {
  hasContent = true;
  ptm.setModelElement(temp_ConcernElement);
  factory.add($result,"elements",convert(temp_ConcernElement),false);
  ptm.ruleFinished(temp_ConcernElement);
} else {
  ptm.destroyNode();
}
}
)+

({skipCurrentToken = false;}'}'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(5)).eContents().get(1)).eContents().get(4)));
  ptm.ruleFinished(getLastToken());
}})
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

ruleConcernElement returns [EObject result]
:
        temp_concern=ruleConcern {$result=temp_concern;}	|        temp_variant=ruleVariant {$result=temp_variant;}	|        temp_pointcut=rulePointCut {$result=temp_pointcut;}	;

ruleVarColElm returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "VarColElm");
			 }
({skipCurrentToken = false;}
RULE_ID
{if (!skipCurrentToken) {
  hasContent = true;
  Token temp = getLastToken();
  ptm.createNode(((EObject)((EObject)xtextfile.eContents().get(8)).eContents().get(1)));
  factory.set($result,"variant",convert(temp),true);
  ptm.ruleFinished(temp);
}}
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

ruleVariant returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "Variant");
			 }
(({skipCurrentToken = false;}'variant'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(9)).eContents().get(1)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}
RULE_ID{if (!skipCurrentToken) {
  hasContent = true;
  Token temp = getLastToken();
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(9)).eContents().get(1)).eContents().get(1)));
  factory.set($result,"name",convert(temp),false);
  ptm.ruleFinished(temp);
}}
)?

({skipCurrentToken = false;}'for'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(9)).eContents().get(1)).eContents().get(2)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(9)).eContents().get(1)).eContents().get(3)));}temp_FeatureExpression=
ruleFeatureExpression{if (temp_FeatureExpression != null) {
  hasContent = true;
  ptm.setModelElement(temp_FeatureExpression);
  factory.set($result,"features",convert(temp_FeatureExpression),false);
  ptm.ruleFinished(temp_FeatureExpression);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}'{'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(9)).eContents().get(1)).eContents().get(4)));
  ptm.ruleFinished(getLastToken());
}})

(({ptm.createNode(((EObject)((EObject)((EObject)((EObject)xtextfile.eContents().get(9)).eContents().get(1)).eContents().get(5)).eContents().get(0)));}temp_Action=
ruleAction{if (temp_Action != null) {
  hasContent = true;
  ptm.setModelElement(temp_Action);
  factory.add($result,"actions",convert(temp_Action),false);
  ptm.ruleFinished(temp_Action);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}';'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)((EObject)xtextfile.eContents().get(9)).eContents().get(1)).eContents().get(5)).eContents().get(1)));
  ptm.ruleFinished(getLastToken());
}})
)+

({skipCurrentToken = false;}'}'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(9)).eContents().get(1)).eContents().get(6)));
  ptm.ruleFinished(getLastToken());
}})
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

ruleVariantOrdering returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "VariantOrdering");
			 }
(({skipCurrentToken = false;}'order'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(10)).eContents().get(1)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(10)).eContents().get(1)).eContents().get(1)));}temp_VarOrderPair=
ruleVarOrderPair{if (temp_VarOrderPair != null) {
  hasContent = true;
  ptm.setModelElement(temp_VarOrderPair);
  factory.add($result,"pairs",convert(temp_VarOrderPair),false);
  ptm.ruleFinished(temp_VarOrderPair);
} else {
  ptm.destroyNode();
}
}
)

(({skipCurrentToken = false;}','{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)((EObject)xtextfile.eContents().get(10)).eContents().get(1)).eContents().get(2)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)((EObject)xtextfile.eContents().get(10)).eContents().get(1)).eContents().get(2)).eContents().get(1)));}temp_VarOrderPair=
ruleVarOrderPair{if (temp_VarOrderPair != null) {
  hasContent = true;
  ptm.setModelElement(temp_VarOrderPair);
  factory.add($result,"pairs",convert(temp_VarOrderPair),false);
  ptm.ruleFinished(temp_VarOrderPair);
} else {
  ptm.destroyNode();
}
}
)
)*

({skipCurrentToken = false;}';'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(10)).eContents().get(1)).eContents().get(3)));
  ptm.ruleFinished(getLastToken());
}})
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

ruleVarOrderPair returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "VarOrderPair");
			 }
(({skipCurrentToken = false;}'('{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(11)).eContents().get(1)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}
RULE_ID
{if (!skipCurrentToken) {
  hasContent = true;
  Token temp = getLastToken();
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(11)).eContents().get(1)).eContents().get(1)));
  factory.set($result,"first",convert(temp),true);
  ptm.ruleFinished(temp);
}}
)

({skipCurrentToken = false;}','{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(11)).eContents().get(1)).eContents().get(2)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}
RULE_ID
{if (!skipCurrentToken) {
  hasContent = true;
  Token temp = getLastToken();
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(11)).eContents().get(1)).eContents().get(3)));
  factory.set($result,"second",convert(temp),true);
  ptm.ruleFinished(temp);
}}
)

({skipCurrentToken = false;}')'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(11)).eContents().get(1)).eContents().get(4)));
  ptm.ruleFinished(getLastToken());
}})
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

ruleFeatureExpression returns [EObject result]
:
        temp_featureexpatom=ruleFeatureExpAtom {$result=temp_featureexpatom;}	|        temp_featureorexp=ruleFeatureOrExp {$result=temp_featureorexp;}	|        temp_featureandexp=ruleFeatureAndExp {$result=temp_featureandexp;}	|        temp_featurenotexp=ruleFeatureNotExp {$result=temp_featurenotexp;}	;

ruleFeatureExpAtom returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "FeatureExpAtom");
			 }
(({skipCurrentToken = false;}
RULE_ID
{if (!skipCurrentToken) {
  hasContent = true;
  Token temp = getLastToken();
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(13)).eContents().get(1)).eContents().get(0)));
  factory.set($result,"feature",convert(temp),true);
  ptm.ruleFinished(temp);
}}
)
	|
(({skipCurrentToken = false;}'{'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)((EObject)xtextfile.eContents().get(13)).eContents().get(1)).eContents().get(1)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}
RULE_STRING{if (!skipCurrentToken) {
  hasContent = true;
  Token temp = getLastToken();
  ptm.createNode(((EObject)((EObject)((EObject)((EObject)xtextfile.eContents().get(13)).eContents().get(1)).eContents().get(1)).eContents().get(1)));
  factory.set($result,"featureName",convert(temp),false);
  ptm.ruleFinished(temp);
}}
)

({skipCurrentToken = false;}'}'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)((EObject)xtextfile.eContents().get(13)).eContents().get(1)).eContents().get(1)).eContents().get(2)));
  ptm.ruleFinished(getLastToken());
}})
)
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

ruleFeatureOrExp returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "FeatureOrExp");
			 }
(({skipCurrentToken = false;}'or'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(14)).eContents().get(1)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}'('{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(14)).eContents().get(1)).eContents().get(1)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(14)).eContents().get(1)).eContents().get(2)));}temp_FeatureExpression=
ruleFeatureExpression{if (temp_FeatureExpression != null) {
  hasContent = true;
  ptm.setModelElement(temp_FeatureExpression);
  factory.add($result,"features",convert(temp_FeatureExpression),false);
  ptm.ruleFinished(temp_FeatureExpression);
} else {
  ptm.destroyNode();
}
}
)

(({skipCurrentToken = false;}','{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)((EObject)xtextfile.eContents().get(14)).eContents().get(1)).eContents().get(3)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)((EObject)xtextfile.eContents().get(14)).eContents().get(1)).eContents().get(3)).eContents().get(1)));}temp_FeatureExpression=
ruleFeatureExpression{if (temp_FeatureExpression != null) {
  hasContent = true;
  ptm.setModelElement(temp_FeatureExpression);
  factory.add($result,"features",convert(temp_FeatureExpression),false);
  ptm.ruleFinished(temp_FeatureExpression);
} else {
  ptm.destroyNode();
}
}
)
)+

({skipCurrentToken = false;}')'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(14)).eContents().get(1)).eContents().get(4)));
  ptm.ruleFinished(getLastToken());
}})
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

ruleFeatureAndExp returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "FeatureAndExp");
			 }
(({skipCurrentToken = false;}'and'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(15)).eContents().get(1)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}'('{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(15)).eContents().get(1)).eContents().get(1)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(15)).eContents().get(1)).eContents().get(2)));}temp_FeatureExpression=
ruleFeatureExpression{if (temp_FeatureExpression != null) {
  hasContent = true;
  ptm.setModelElement(temp_FeatureExpression);
  factory.add($result,"features",convert(temp_FeatureExpression),false);
  ptm.ruleFinished(temp_FeatureExpression);
} else {
  ptm.destroyNode();
}
}
)

(({skipCurrentToken = false;}','{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)((EObject)xtextfile.eContents().get(15)).eContents().get(1)).eContents().get(3)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)((EObject)xtextfile.eContents().get(15)).eContents().get(1)).eContents().get(3)).eContents().get(1)));}temp_FeatureExpression=
ruleFeatureExpression{if (temp_FeatureExpression != null) {
  hasContent = true;
  ptm.setModelElement(temp_FeatureExpression);
  factory.add($result,"features",convert(temp_FeatureExpression),false);
  ptm.ruleFinished(temp_FeatureExpression);
} else {
  ptm.destroyNode();
}
}
)
)+

({skipCurrentToken = false;}')'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(15)).eContents().get(1)).eContents().get(4)));
  ptm.ruleFinished(getLastToken());
}})
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

ruleFeatureNotExp returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "FeatureNotExp");
			 }
(({skipCurrentToken = false;}'not'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(16)).eContents().get(1)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}'('{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(16)).eContents().get(1)).eContents().get(1)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(16)).eContents().get(1)).eContents().get(2)));}temp_FeatureExpression=
ruleFeatureExpression{if (temp_FeatureExpression != null) {
  hasContent = true;
  ptm.setModelElement(temp_FeatureExpression);
  factory.set($result,"features",convert(temp_FeatureExpression),false);
  ptm.ruleFinished(temp_FeatureExpression);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}')'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(16)).eContents().get(1)).eContents().get(3)));
  ptm.ruleFinished(getLastToken());
}})
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

rulePointCut returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "PointCut");
			 }
(({skipCurrentToken = false;}'pointcut'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(17)).eContents().get(1)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}
RULE_ID{if (!skipCurrentToken) {
  hasContent = true;
  Token temp = getLastToken();
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(17)).eContents().get(1)).eContents().get(1)));
  factory.set($result,"name",convert(temp),false);
  ptm.ruleFinished(temp);
}}
)

({skipCurrentToken = false;}'{'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(17)).eContents().get(1)).eContents().get(2)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(17)).eContents().get(1)).eContents().get(3)));}temp_PointCutExpression=
rulePointCutExpression{if (temp_PointCutExpression != null) {
  hasContent = true;
  ptm.setModelElement(temp_PointCutExpression);
  factory.set($result,"pce",convert(temp_PointCutExpression),false);
  ptm.ruleFinished(temp_PointCutExpression);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}'}'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(17)).eContents().get(1)).eContents().get(4)));
  ptm.ruleFinished(getLastToken());
}})
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

rulePointCutReference returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "PointCutReference");
			 }
(({skipCurrentToken = false;}'pcref'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(18)).eContents().get(1)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}
RULE_ID
{if (!skipCurrentToken) {
  hasContent = true;
  Token temp = getLastToken();
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(18)).eContents().get(1)).eContents().get(1)));
  factory.set($result,"pc",convert(temp),true);
  ptm.ruleFinished(temp);
}}
)
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

rulePointCutExpression returns [EObject result]
:
        temp_pcdesignator=rulePCDesignator {$result=temp_pcdesignator;}	|        temp_pceoperator=rulePCEOperator {$result=temp_pceoperator;}	;

rulePCDesignator returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "PCDesignator");
			 }
({skipCurrentToken = false;}
RULE_STRING{if (!skipCurrentToken) {
  hasContent = true;
  Token temp = getLastToken();
  ptm.createNode(((EObject)((EObject)xtextfile.eContents().get(20)).eContents().get(1)));
  factory.set($result,"pceExpression",convert(temp),false);
  ptm.ruleFinished(temp);
}}
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

rulePCEOperator returns [EObject result]
:
        temp_pceandoperator=rulePCEAndOperator {$result=temp_pceandoperator;}	|        temp_pceoroperator=rulePCEOrOperator {$result=temp_pceoroperator;}	;

rulePCEAndOperator returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "PCEAndOperator");
			 }
(({skipCurrentToken = false;}'and'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(22)).eContents().get(1)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}'('{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(22)).eContents().get(1)).eContents().get(1)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(22)).eContents().get(1)).eContents().get(2)));}temp_PointCutExpression=
rulePointCutExpression{if (temp_PointCutExpression != null) {
  hasContent = true;
  ptm.setModelElement(temp_PointCutExpression);
  factory.add($result,"operands",convert(temp_PointCutExpression),false);
  ptm.ruleFinished(temp_PointCutExpression);
} else {
  ptm.destroyNode();
}
}
)

(({skipCurrentToken = false;}','{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)((EObject)xtextfile.eContents().get(22)).eContents().get(1)).eContents().get(3)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)((EObject)xtextfile.eContents().get(22)).eContents().get(1)).eContents().get(3)).eContents().get(1)));}temp_PointCutExpression=
rulePointCutExpression{if (temp_PointCutExpression != null) {
  hasContent = true;
  ptm.setModelElement(temp_PointCutExpression);
  factory.add($result,"operands",convert(temp_PointCutExpression),false);
  ptm.ruleFinished(temp_PointCutExpression);
} else {
  ptm.destroyNode();
}
}
)
)+

({skipCurrentToken = false;}')'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(22)).eContents().get(1)).eContents().get(4)));
  ptm.ruleFinished(getLastToken());
}})
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

rulePCEOrOperator returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "PCEOrOperator");
			 }
(({skipCurrentToken = false;}'or'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(23)).eContents().get(1)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}'('{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(23)).eContents().get(1)).eContents().get(1)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(23)).eContents().get(1)).eContents().get(2)));}temp_PointCutExpression=
rulePointCutExpression{if (temp_PointCutExpression != null) {
  hasContent = true;
  ptm.setModelElement(temp_PointCutExpression);
  factory.add($result,"operands",convert(temp_PointCutExpression),false);
  ptm.ruleFinished(temp_PointCutExpression);
} else {
  ptm.destroyNode();
}
}
)

(({skipCurrentToken = false;}','{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)((EObject)xtextfile.eContents().get(23)).eContents().get(1)).eContents().get(3)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)((EObject)xtextfile.eContents().get(23)).eContents().get(1)).eContents().get(3)).eContents().get(1)));}temp_PointCutExpression=
rulePointCutExpression{if (temp_PointCutExpression != null) {
  hasContent = true;
  ptm.setModelElement(temp_PointCutExpression);
  factory.add($result,"operands",convert(temp_PointCutExpression),false);
  ptm.ruleFinished(temp_PointCutExpression);
} else {
  ptm.destroyNode();
}
}
)
)+

({skipCurrentToken = false;}')'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(23)).eContents().get(1)).eContents().get(4)));
  ptm.ruleFinished(getLastToken());
}})
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

ruleElementReference returns [EObject result]
:
        temp_pointcutexpression=rulePointCutExpression {$result=temp_pointcutexpression;}	|        temp_pointcutreference=rulePointCutReference {$result=temp_pointcutreference;}	;

ruleAction returns [EObject result]
:
        temp_connectaction=ruleConnectAction {$result=temp_connectaction;}	|        temp_removeaction=ruleRemoveAction {$result=temp_removeaction;}	|        temp_createpackageaction=ruleCreatePackageAction {$result=temp_createpackageaction;}	|        temp_createcomponentinstanceaction=ruleCreateComponentInstanceAction {$result=temp_createcomponentinstanceaction;}	|        temp_setdefaultliteralattributeaction=ruleSetDefaultLiteralAttributeAction {$result=temp_setdefaultliteralattributeaction;}	|        temp_setdefaultattributeaction=ruleSetDefaultAttributeAction {$result=temp_setdefaultattributeaction;}	|        temp_setliteralattributeaction=ruleSetLiteralAttributeAction {$result=temp_setliteralattributeaction;}	|        temp_setattributeaction=ruleSetAttributeAction {$result=temp_setattributeaction;}	|        temp_mergeaction=ruleMergeAction {$result=temp_mergeaction;}	|        temp_createconnectoraction=ruleCreateConnectorAction {$result=temp_createconnectoraction;}	|        temp_connectportsaction=ruleConnectPortsAction {$result=temp_connectportsaction;}	;

ruleConnectAction returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "ConnectAction");
			 }
(({skipCurrentToken = false;}'connect'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(26)).eContents().get(1)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}'('{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(26)).eContents().get(1)).eContents().get(1)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(26)).eContents().get(1)).eContents().get(2)));}temp_ElementReference=
ruleElementReference{if (temp_ElementReference != null) {
  hasContent = true;
  ptm.setModelElement(temp_ElementReference);
  factory.add($result,"parameters",convert(temp_ElementReference),false);
  ptm.ruleFinished(temp_ElementReference);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}','{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(26)).eContents().get(1)).eContents().get(3)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(26)).eContents().get(1)).eContents().get(4)));}temp_ElementReference=
ruleElementReference{if (temp_ElementReference != null) {
  hasContent = true;
  ptm.setModelElement(temp_ElementReference);
  factory.add($result,"parameters",convert(temp_ElementReference),false);
  ptm.ruleFinished(temp_ElementReference);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}','{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(26)).eContents().get(1)).eContents().get(5)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(26)).eContents().get(1)).eContents().get(6)));}temp_ElementReference=
ruleElementReference{if (temp_ElementReference != null) {
  hasContent = true;
  ptm.setModelElement(temp_ElementReference);
  factory.add($result,"parameters",convert(temp_ElementReference),false);
  ptm.ruleFinished(temp_ElementReference);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}')'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(26)).eContents().get(1)).eContents().get(7)));
  ptm.ruleFinished(getLastToken());
}})
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

ruleRemoveAction returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "RemoveAction");
			 }
(({skipCurrentToken = false;}'remove'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(27)).eContents().get(1)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}'('{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(27)).eContents().get(1)).eContents().get(1)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(27)).eContents().get(1)).eContents().get(2)));}temp_ElementReference=
ruleElementReference{if (temp_ElementReference != null) {
  hasContent = true;
  ptm.setModelElement(temp_ElementReference);
  factory.add($result,"parameters",convert(temp_ElementReference),false);
  ptm.ruleFinished(temp_ElementReference);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}')'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(27)).eContents().get(1)).eContents().get(3)));
  ptm.ruleFinished(getLastToken());
}})
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

ruleCreatePackageAction returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "CreatePackageAction");
			 }
(({skipCurrentToken = false;}'createPackage'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(28)).eContents().get(1)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}'('{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(28)).eContents().get(1)).eContents().get(1)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(28)).eContents().get(1)).eContents().get(2)));}temp_ElementReference=
ruleElementReference{if (temp_ElementReference != null) {
  hasContent = true;
  ptm.setModelElement(temp_ElementReference);
  factory.add($result,"parameters",convert(temp_ElementReference),false);
  ptm.ruleFinished(temp_ElementReference);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}','{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(28)).eContents().get(1)).eContents().get(3)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(28)).eContents().get(1)).eContents().get(4)));}temp_ElementReference=
ruleElementReference{if (temp_ElementReference != null) {
  hasContent = true;
  ptm.setModelElement(temp_ElementReference);
  factory.add($result,"parameters",convert(temp_ElementReference),false);
  ptm.ruleFinished(temp_ElementReference);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}')'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(28)).eContents().get(1)).eContents().get(5)));
  ptm.ruleFinished(getLastToken());
}})
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

ruleCreateComponentInstanceAction returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "CreateComponentInstanceAction");
			 }
(({skipCurrentToken = false;}'createComponentInstance'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(29)).eContents().get(1)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}'('{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(29)).eContents().get(1)).eContents().get(1)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(29)).eContents().get(1)).eContents().get(2)));}temp_ElementReference=
ruleElementReference{if (temp_ElementReference != null) {
  hasContent = true;
  ptm.setModelElement(temp_ElementReference);
  factory.add($result,"parameters",convert(temp_ElementReference),false);
  ptm.ruleFinished(temp_ElementReference);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}','{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(29)).eContents().get(1)).eContents().get(3)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(29)).eContents().get(1)).eContents().get(4)));}temp_ElementReference=
ruleElementReference{if (temp_ElementReference != null) {
  hasContent = true;
  ptm.setModelElement(temp_ElementReference);
  factory.add($result,"parameters",convert(temp_ElementReference),false);
  ptm.ruleFinished(temp_ElementReference);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}')'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(29)).eContents().get(1)).eContents().get(5)));
  ptm.ruleFinished(getLastToken());
}})
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

ruleSetDefaultLiteralAttributeAction returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "SetDefaultLiteralAttributeAction");
			 }
(({skipCurrentToken = false;}'setDefaultLiteralAttribute'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(30)).eContents().get(1)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}'('{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(30)).eContents().get(1)).eContents().get(1)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(30)).eContents().get(1)).eContents().get(2)));}temp_ElementReference=
ruleElementReference{if (temp_ElementReference != null) {
  hasContent = true;
  ptm.setModelElement(temp_ElementReference);
  factory.add($result,"parameters",convert(temp_ElementReference),false);
  ptm.ruleFinished(temp_ElementReference);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}','{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(30)).eContents().get(1)).eContents().get(3)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(30)).eContents().get(1)).eContents().get(4)));}temp_ElementReference=
ruleElementReference{if (temp_ElementReference != null) {
  hasContent = true;
  ptm.setModelElement(temp_ElementReference);
  factory.add($result,"parameters",convert(temp_ElementReference),false);
  ptm.ruleFinished(temp_ElementReference);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}')'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(30)).eContents().get(1)).eContents().get(5)));
  ptm.ruleFinished(getLastToken());
}})
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

ruleSetDefaultAttributeAction returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "SetDefaultAttributeAction");
			 }
(({skipCurrentToken = false;}'setDefaultAttribute'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(31)).eContents().get(1)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}'('{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(31)).eContents().get(1)).eContents().get(1)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(31)).eContents().get(1)).eContents().get(2)));}temp_ElementReference=
ruleElementReference{if (temp_ElementReference != null) {
  hasContent = true;
  ptm.setModelElement(temp_ElementReference);
  factory.add($result,"parameters",convert(temp_ElementReference),false);
  ptm.ruleFinished(temp_ElementReference);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}','{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(31)).eContents().get(1)).eContents().get(3)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(31)).eContents().get(1)).eContents().get(4)));}temp_ElementReference=
ruleElementReference{if (temp_ElementReference != null) {
  hasContent = true;
  ptm.setModelElement(temp_ElementReference);
  factory.add($result,"parameters",convert(temp_ElementReference),false);
  ptm.ruleFinished(temp_ElementReference);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}')'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(31)).eContents().get(1)).eContents().get(5)));
  ptm.ruleFinished(getLastToken());
}})
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

ruleSetLiteralAttributeAction returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "SetLiteralAttributeAction");
			 }
(({skipCurrentToken = false;}'setLiteralAttribute'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(32)).eContents().get(1)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}'('{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(32)).eContents().get(1)).eContents().get(1)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(32)).eContents().get(1)).eContents().get(2)));}temp_ElementReference=
ruleElementReference{if (temp_ElementReference != null) {
  hasContent = true;
  ptm.setModelElement(temp_ElementReference);
  factory.add($result,"parameters",convert(temp_ElementReference),false);
  ptm.ruleFinished(temp_ElementReference);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}','{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(32)).eContents().get(1)).eContents().get(3)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(32)).eContents().get(1)).eContents().get(4)));}temp_ElementReference=
ruleElementReference{if (temp_ElementReference != null) {
  hasContent = true;
  ptm.setModelElement(temp_ElementReference);
  factory.add($result,"parameters",convert(temp_ElementReference),false);
  ptm.ruleFinished(temp_ElementReference);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}','{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(32)).eContents().get(1)).eContents().get(5)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(32)).eContents().get(1)).eContents().get(6)));}temp_ElementReference=
ruleElementReference{if (temp_ElementReference != null) {
  hasContent = true;
  ptm.setModelElement(temp_ElementReference);
  factory.add($result,"parameters",convert(temp_ElementReference),false);
  ptm.ruleFinished(temp_ElementReference);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}')'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(32)).eContents().get(1)).eContents().get(7)));
  ptm.ruleFinished(getLastToken());
}})
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

ruleSetAttributeAction returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "SetAttributeAction");
			 }
(({skipCurrentToken = false;}'setAttribute'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(33)).eContents().get(1)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}'('{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(33)).eContents().get(1)).eContents().get(1)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(33)).eContents().get(1)).eContents().get(2)));}temp_ElementReference=
ruleElementReference{if (temp_ElementReference != null) {
  hasContent = true;
  ptm.setModelElement(temp_ElementReference);
  factory.add($result,"parameters",convert(temp_ElementReference),false);
  ptm.ruleFinished(temp_ElementReference);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}','{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(33)).eContents().get(1)).eContents().get(3)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(33)).eContents().get(1)).eContents().get(4)));}temp_ElementReference=
ruleElementReference{if (temp_ElementReference != null) {
  hasContent = true;
  ptm.setModelElement(temp_ElementReference);
  factory.add($result,"parameters",convert(temp_ElementReference),false);
  ptm.ruleFinished(temp_ElementReference);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}','{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(33)).eContents().get(1)).eContents().get(5)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(33)).eContents().get(1)).eContents().get(6)));}temp_ElementReference=
ruleElementReference{if (temp_ElementReference != null) {
  hasContent = true;
  ptm.setModelElement(temp_ElementReference);
  factory.add($result,"parameters",convert(temp_ElementReference),false);
  ptm.ruleFinished(temp_ElementReference);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}')'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(33)).eContents().get(1)).eContents().get(7)));
  ptm.ruleFinished(getLastToken());
}})
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

ruleMergeAction returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "MergeAction");
			 }
(({skipCurrentToken = false;}'merge'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(34)).eContents().get(1)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}'('{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(34)).eContents().get(1)).eContents().get(1)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(34)).eContents().get(1)).eContents().get(2)));}temp_ElementReference=
ruleElementReference{if (temp_ElementReference != null) {
  hasContent = true;
  ptm.setModelElement(temp_ElementReference);
  factory.add($result,"parameters",convert(temp_ElementReference),false);
  ptm.ruleFinished(temp_ElementReference);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}','{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(34)).eContents().get(1)).eContents().get(3)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(34)).eContents().get(1)).eContents().get(4)));}temp_ElementReference=
ruleElementReference{if (temp_ElementReference != null) {
  hasContent = true;
  ptm.setModelElement(temp_ElementReference);
  factory.add($result,"parameters",convert(temp_ElementReference),false);
  ptm.ruleFinished(temp_ElementReference);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}')'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(34)).eContents().get(1)).eContents().get(5)));
  ptm.ruleFinished(getLastToken());
}})
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

ruleCreateConnectorAction returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "CreateConnectorAction");
			 }
(({skipCurrentToken = false;}'createConnector'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(35)).eContents().get(1)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}'('{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(35)).eContents().get(1)).eContents().get(1)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(35)).eContents().get(1)).eContents().get(2)));}temp_ElementReference=
ruleElementReference{if (temp_ElementReference != null) {
  hasContent = true;
  ptm.setModelElement(temp_ElementReference);
  factory.add($result,"parameters",convert(temp_ElementReference),false);
  ptm.ruleFinished(temp_ElementReference);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}','{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(35)).eContents().get(1)).eContents().get(3)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(35)).eContents().get(1)).eContents().get(4)));}temp_ElementReference=
ruleElementReference{if (temp_ElementReference != null) {
  hasContent = true;
  ptm.setModelElement(temp_ElementReference);
  factory.add($result,"parameters",convert(temp_ElementReference),false);
  ptm.ruleFinished(temp_ElementReference);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}','{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(35)).eContents().get(1)).eContents().get(5)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(35)).eContents().get(1)).eContents().get(6)));}temp_ElementReference=
ruleElementReference{if (temp_ElementReference != null) {
  hasContent = true;
  ptm.setModelElement(temp_ElementReference);
  factory.add($result,"parameters",convert(temp_ElementReference),false);
  ptm.ruleFinished(temp_ElementReference);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}','{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(35)).eContents().get(1)).eContents().get(7)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(35)).eContents().get(1)).eContents().get(8)));}temp_ElementReference=
ruleElementReference{if (temp_ElementReference != null) {
  hasContent = true;
  ptm.setModelElement(temp_ElementReference);
  factory.add($result,"parameters",convert(temp_ElementReference),false);
  ptm.ruleFinished(temp_ElementReference);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}','{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(35)).eContents().get(1)).eContents().get(9)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(35)).eContents().get(1)).eContents().get(10)));}temp_ElementReference=
ruleElementReference{if (temp_ElementReference != null) {
  hasContent = true;
  ptm.setModelElement(temp_ElementReference);
  factory.add($result,"parameters",convert(temp_ElementReference),false);
  ptm.ruleFinished(temp_ElementReference);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}')'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(35)).eContents().get(1)).eContents().get(11)));
  ptm.ruleFinished(getLastToken());
}})
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

ruleConnectPortsAction returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "ConnectPortsAction");
			 }
(({skipCurrentToken = false;}'connectPorts'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(36)).eContents().get(1)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}'('{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(36)).eContents().get(1)).eContents().get(1)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(36)).eContents().get(1)).eContents().get(2)));}temp_ElementReference=
ruleElementReference{if (temp_ElementReference != null) {
  hasContent = true;
  ptm.setModelElement(temp_ElementReference);
  factory.add($result,"parameters",convert(temp_ElementReference),false);
  ptm.ruleFinished(temp_ElementReference);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}','{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(36)).eContents().get(1)).eContents().get(3)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(36)).eContents().get(1)).eContents().get(4)));}temp_ElementReference=
ruleElementReference{if (temp_ElementReference != null) {
  hasContent = true;
  ptm.setModelElement(temp_ElementReference);
  factory.add($result,"parameters",convert(temp_ElementReference),false);
  ptm.ruleFinished(temp_ElementReference);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}','{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(36)).eContents().get(1)).eContents().get(5)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(36)).eContents().get(1)).eContents().get(6)));}temp_ElementReference=
ruleElementReference{if (temp_ElementReference != null) {
  hasContent = true;
  ptm.setModelElement(temp_ElementReference);
  factory.add($result,"parameters",convert(temp_ElementReference),false);
  ptm.ruleFinished(temp_ElementReference);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}','{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(36)).eContents().get(1)).eContents().get(7)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(36)).eContents().get(1)).eContents().get(8)));}temp_ElementReference=
ruleElementReference{if (temp_ElementReference != null) {
  hasContent = true;
  ptm.setModelElement(temp_ElementReference);
  factory.add($result,"parameters",convert(temp_ElementReference),false);
  ptm.ruleFinished(temp_ElementReference);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}','{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(36)).eContents().get(1)).eContents().get(9)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(36)).eContents().get(1)).eContents().get(10)));}temp_ElementReference=
ruleElementReference{if (temp_ElementReference != null) {
  hasContent = true;
  ptm.setModelElement(temp_ElementReference);
  factory.add($result,"parameters",convert(temp_ElementReference),false);
  ptm.ruleFinished(temp_ElementReference);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}','{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(36)).eContents().get(1)).eContents().get(11)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(36)).eContents().get(1)).eContents().get(12)));}temp_ElementReference=
ruleElementReference{if (temp_ElementReference != null) {
  hasContent = true;
  ptm.setModelElement(temp_ElementReference);
  factory.add($result,"parameters",convert(temp_ElementReference),false);
  ptm.ruleFinished(temp_ElementReference);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}')'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(36)).eContents().get(1)).eContents().get(13)));
  ptm.ruleFinished(getLastToken());
}})
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

RULE_ID :

	 ('^')?('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*
	 
;

RULE_STRING :

	 '\"' ( '\\' ('b'|'t'|'n'|'f'|'r'|'\"'|'\''|'\\') | ~('\\'|'\"') )* '\"' |
	 '\'' ( '\\' ('b'|'t'|'n'|'f'|'r'|'\"'|'\''|'\\') | ~('\\'|'\'') )* '\''
	 
;

RULE_INT :

	 ('-')?('0'..'9')+
	 
;

RULE_WS :

	 (' '|'\t'|'\r'|'\n')+ {$channel=HIDDEN;}
	 
;

RULE_ML_COMMENT :

	 '/*' ( options {greedy=false;} : . )* '*/' {$channel=HIDDEN;}
	 
;

RULE_SL_COMMENT :

	 '//' ~('\n'|'\r')* '\r'? '\n' {$channel=HIDDEN;}
	 
;

