lexer grammar vml4arch;
@members {
	 private List<ErrorMsg> errors = new ArrayList<ErrorMsg>();
	public List<ErrorMsg> getErrors() {
		return errors;
	}

	public String getErrorMessage(RecognitionException e, String[] tokenNames) {
		String msg = super.getErrorMessage(e,tokenNames);
		errors.add(AntlrUtil.create(msg,e,tokenNames));
		return msg;
	}
}
@header {
package org.ample.vml.vml4arch.parser;

import org.openarchitectureware.xtext.parser.ErrorMsg;
import org.openarchitectureware.xtext.parser.impl.AntlrUtil;

}

T10 : 'import' ;
T11 : 'features' ;
T12 : '<' ;
T13 : '>' ;
T14 : ';' ;
T15 : 'feature' ;
T16 : 'core' ;
T17 : 'concern' ;
T18 : '{' ;
T19 : '}' ;
T20 : 'variant' ;
T21 : 'for' ;
T22 : 'order' ;
T23 : ',' ;
T24 : '(' ;
T25 : ')' ;
T26 : 'or' ;
T27 : 'and' ;
T28 : 'not' ;
T29 : 'pointcut' ;
T30 : 'pcref' ;
T31 : 'connect' ;
T32 : 'remove' ;
T33 : 'createPackage' ;
T34 : 'createComponentInstance' ;
T35 : 'setDefaultLiteralAttribute' ;
T36 : 'setDefaultAttribute' ;
T37 : 'setLiteralAttribute' ;
T38 : 'setAttribute' ;
T39 : 'merge' ;
T40 : 'createConnector' ;
T41 : 'connectPorts' ;

// $ANTLR src "..//org.ample.vml.vml4arch/src-gen/org/ample/vml/vml4arch/parser/vml4arch.g" 1873
RULE_ID :

	 ('^')?('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*
	 
;

// $ANTLR src "..//org.ample.vml.vml4arch/src-gen/org/ample/vml/vml4arch/parser/vml4arch.g" 1879
RULE_STRING :

	 '\"' ( '\\' ('b'|'t'|'n'|'f'|'r'|'\"'|'\''|'\\') | ~('\\'|'\"') )* '\"' |
	 '\'' ( '\\' ('b'|'t'|'n'|'f'|'r'|'\"'|'\''|'\\') | ~('\\'|'\'') )* '\''
	 
;

// $ANTLR src "..//org.ample.vml.vml4arch/src-gen/org/ample/vml/vml4arch/parser/vml4arch.g" 1886
RULE_INT :

	 ('-')?('0'..'9')+
	 
;

// $ANTLR src "..//org.ample.vml.vml4arch/src-gen/org/ample/vml/vml4arch/parser/vml4arch.g" 1892
RULE_WS :

	 (' '|'\t'|'\r'|'\n')+ {$channel=HIDDEN;}
	 
;

// $ANTLR src "..//org.ample.vml.vml4arch/src-gen/org/ample/vml/vml4arch/parser/vml4arch.g" 1898
RULE_ML_COMMENT :

	 '/*' ( options {greedy=false;} : . )* '*/' {$channel=HIDDEN;}
	 
;

// $ANTLR src "..//org.ample.vml.vml4arch/src-gen/org/ample/vml/vml4arch/parser/vml4arch.g" 1904
RULE_SL_COMMENT :

	 '//' ~('\n'|'\r')* '\r'? '\n' {$channel=HIDDEN;}
	 
;

