lexer grammar vml4req;
@members {
	 private List<ErrorMsg> errors = new ArrayList<ErrorMsg>();
	public List<ErrorMsg> getErrors() {
		return errors;
	}

	public String getErrorMessage(RecognitionException e, String[] tokenNames) {
		String msg = super.getErrorMessage(e,tokenNames);
		errors.add(AntlrUtil.create(msg,e,tokenNames));
		return msg;
	}
}
@header {
package org.ample.vml.vml4req.parser;

import org.openarchitectureware.xtext.parser.ErrorMsg;
import org.openarchitectureware.xtext.parser.impl.AntlrUtil;

}

T10 : 'atf' ;
T11 : 'import' ;
T12 : 'features' ;
T13 : '<' ;
T14 : '>' ;
T15 : ';' ;
T16 : 'feature' ;
T17 : 'core' ;
T18 : 'concern' ;
T19 : '{' ;
T20 : '}' ;
T21 : 'variant' ;
T22 : 'for' ;
T23 : 'order' ;
T24 : ',' ;
T25 : '(' ;
T26 : ')' ;
T27 : 'or' ;
T28 : 'and' ;
T29 : 'not' ;
T30 : 'pointcut' ;
T31 : 'pcref' ;
T32 : 'trace' ;
T33 : 'createInclude' ;
T34 : 'createExtends' ;
T35 : 'createInherits' ;
T36 : 'createAssociation' ;
T37 : 'insertUseCase' ;
T38 : 'insertActor' ;
T39 : 'insertPackage' ;
T40 : 'removeUseCase' ;
T41 : 'removeActor' ;
T42 : 'removePackage' ;
T43 : 'removeElement' ;
T44 : 'removeAction' ;
T45 : 'removeObjectAction' ;
T46 : 'createAction' ;
T47 : 'createObjectAction' ;
T48 : 'createActivityParameter' ;
T49 : 'createOutputPin' ;
T50 : 'createDecisionNode' ;
T51 : 'connectActions' ;
T52 : 'connectPins' ;
T53 : 'connectActionsWithGuard' ;
T54 : 'connectActivityElements' ;
T55 : 'replaceActionByActivity' ;
T56 : 'createActivityModel' ;
T57 : 'removeActivityModel' ;
T58 : 'connectActionWithInitialNode' ;
T59 : 'connectActionWithFinalNode' ;

// $ANTLR src "..//org.ample.vml.vml4req/src-gen/org/ample/vml/vml4req/parser/vml4req.g" 2693
RULE_ID :

	 ('^')?('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*
	 
;

// $ANTLR src "..//org.ample.vml.vml4req/src-gen/org/ample/vml/vml4req/parser/vml4req.g" 2699
RULE_STRING :

	 '\"' ( '\\' ('b'|'t'|'n'|'f'|'r'|'\"'|'\''|'\\') | ~('\\'|'\"') )* '\"' |
	 '\'' ( '\\' ('b'|'t'|'n'|'f'|'r'|'\"'|'\''|'\\') | ~('\\'|'\'') )* '\''
	 
;

// $ANTLR src "..//org.ample.vml.vml4req/src-gen/org/ample/vml/vml4req/parser/vml4req.g" 2706
RULE_INT :

	 ('-')?('0'..'9')+
	 
;

// $ANTLR src "..//org.ample.vml.vml4req/src-gen/org/ample/vml/vml4req/parser/vml4req.g" 2712
RULE_WS :

	 (' '|'\t'|'\r'|'\n')+ {$channel=HIDDEN;}
	 
;

// $ANTLR src "..//org.ample.vml.vml4req/src-gen/org/ample/vml/vml4req/parser/vml4req.g" 2718
RULE_ML_COMMENT :

	 '/*' ( options {greedy=false;} : . )* '*/' {$channel=HIDDEN;}
	 
;

// $ANTLR src "..//org.ample.vml.vml4req/src-gen/org/ample/vml/vml4req/parser/vml4req.g" 2724
RULE_SL_COMMENT :

	 '//' ~('\n'|'\r')* '\r'? '\n' {$channel=HIDDEN;}
	 
;

