package fct.ample.REVMLInterpretor.FMPUtils;




/**
 * Class ConfigFmpElements represents configuration FMP Elements including the id, attributes and state.
 * @author Andre Sousa 
 */
public class ConfigFmpElement {
	static final long serialVersionUID = 3;

	private String id;
	private FeatureProperties properties;
	private String state;

	/**
	 * The default constructor for {@link ConfigFmpElement}.
	 */
	public ConfigFmpElement() {
		this.id = new String();
		this.properties = new FeatureProperties();
		this.state = null;
	}

	/**
	 * The constructor for {@link ConfigFmpElement}.
	 * @param id The ID of the element.
	 */
	public ConfigFmpElement(String id, FeatureProperties properties) {
		this.id = id;
		this.properties = properties;
		this.state = null;
	}

	/**
	 * The constructor for {@link ConfigFmpElement}.
	 * @param id The ID of the element.
	 * @param state The state of the element.
	 */
	public ConfigFmpElement(String id, FeatureProperties properties, String state) {
		this.id = id;
		this.properties = properties;
		this.state = state;
	}

	/**
	 * 
	 * @return
	 */
	public String getId() {
		return id;
	}

	/**
	 * 
	 * @param id
	 */
	public void setId(String id) {
		this.id = id;
	}

	/**
	 * 
	 * @return
	 */
	public String getState() {
		return state;
	}

	/**
	 * 
	 * @param state
	 */
	public void setState(String state) {
		this.state = state;
	}

	/**
	 * 
	 * @return
	 */
	public FeatureProperties getProperties() {
		return properties;
	}

	/**
	 * 
	 * @param properties
	 */
	public void setProperties(FeatureProperties properties) {
		this.properties = properties;
	}

	/**
	 * 
	 */
	public String toString() {
		String result = "\n\nid = " + id + "\n";
		result += "state = " + state + "\n";
		result += properties.toString();
		return result;
	}

	/**
	 * 
	 */
	public void printFmpElement() {
		System.out.println();
		System.out.println(toString());
	}
}