package fct.ample.REVMLInterpretor.FMPUtils;


import org.jdom.Element;
import org.jdom.filter.Filter;


/**
 * class ElementNameFilter implements a Filter for {@link Element} names.
 * @author Andre Sousa
 */
public class ElementNameFilter implements Filter {
	static final long serialVersionUID = 1;

	private String name;

	/**
	 * The standard constructor for the class.
	 * @param name The name to be used for the method matches. 
	 */
	public ElementNameFilter(String name) {
		this.name = name;
	}

	/**
	 * This method implements the matches method of {@link Filter} interface.
	 * It checks to see if a given object of type {@link Element} has the same name as the configured on the filter.
	 *   
	 */
	public boolean matches(Object check) {
		if (check instanceof Element)
			if(((Element)check).getName().equals(name))
				return true;
		return false;
	}
}