package fct.ample.REVMLInterpretor.FMPUtils;


/**
 * class FeatureAttributes implements a triple containing feature properties: name, min and max.
 * @author Andre Sousa
 */
public class FeatureProperties {
	static final long serialVersionUID = 2;

	private String name;
	private Integer min;
	private Integer max;

	/**
	 * The default constructor for {@link FeatureProperties}.
	 */
	public FeatureProperties() {
		this.name = new String();
		this.min = null;
		this.max = null;		
	}

	/**
	 * The constructor for {@link FeatureProperties}.
	 * @param name The name of the feature.
	 * @param min The min occurrences of the feature.
	 * @param max The max occurrences of the feature.
	 */
	public FeatureProperties(String name, int min, int max) {
		this.name = name;
		this.min = new Integer(min);
		this.max = new Integer(max);		
	}

	/**
	 * 
	 * @return
	 */
	public int getMax() {
		return max.intValue();
	}

	/**
	 * 
	 * @param max
	 */
	public void setMax(int max) {
		this.max = max;
	}

	/**
	 * 
	 * @return
	 */
	public int getMin() {
		return min.intValue();
	}

	/**
	 * 
	 * @param min
	 */
	public void setMin(int min) {
		this.min = min;
	}

	/**
	 * 
	 * @return
	 */
	public String getName() {
		return name;
	}

	/**
	 * 
	 * @param name
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * 
	 */
	public void printFeatureAttributes() {
		System.out.println(toString());
	}

	/**
	 * 
	 * @return
	 */
	public String toString() {
		String result = "--------\n";
		result += "Feature Properties\n";
		result += "name = " + name + "\n";
		result += "min = " + min + "\n";
		result += "max = " + max + "\n";
		result += "--------";
		return result;
	}
}