package fct.ample.REVMLInterpretor.FMPUtils;



/**
 * class FeatureAttributes implements a triple containing feature model attributes: type, min and max.
 * @author Andre Sousa
 */
public class FmpAttribute {
	static final long serialVersionUID = 15;

	private String id;
	private String type;
	private Integer min;
	private Integer max;

	/**
	 * The default constructor for {@link FeatureAttributes}.
	 */
	public FmpAttribute() {
		this.id = new String();
		this.type = new String();
		this.min = new Integer(0);
		this.max = new Integer(0);
	}

	/**
	 * The constructor for {@link FeatureAttributes}.
	 * @param id The id of the attribute.
	 * @param type The type of the attribute.
	 * @param min The min occurrences of the attribute.
	 * @param max The max occurrences of the attribute.
	 */
	public FmpAttribute(String id, String type, int min, int max) {
		this.id = id;
		this.type = type;
		this.min = new Integer(min);
		this.max = new Integer(max);		
	}

	/**
	 * @return the id
	 */
	public String getId() {
		return id;
	}

	/**
	 * @param id the id to set
	 */
	public void setId(String id) {
		this.id = id;
	}

	/**
	 * @return the type
	 */
	public String getType() {
		return type;
	}

	/**
	 * @param type the type to set
	 */
	public void setType(String type) {
		this.type = type;
	}

	/**
	 * @return the min
	 */
	public Integer getMin() {
		return min;
	}

	/**
	 * @param min the min to set
	 */
	public void setMin(Integer min) {
		this.min = min;
	}

	/**
	 * @return the max
	 */
	public Integer getMax() {
		return max;
	}

	/**
	 * @param max the max to set
	 */
	public void setMax(Integer max) {
		this.max = max;
	}

	/**
	 * 
	 */
	public void printFeatureAttributes() {
		System.out.println("--------");
		System.out.println("Feature model Attribute");
		System.out.println("id = " + id);
		System.out.println("type = " + type);
		System.out.println("min = " + min);
		System.out.println("max = " + max);
		System.out.println("--------");
	}

	/**
	 * 
	 * @return
	 */
	public String toString() {
		String result = "--------\n";
		result += "Feature model Attribute\n";
		result += "id = " + id + "\n";
		result += "type = " + type + "\n";
		result += "min = " + min + "\n";
		result += "max = " + max + "\n";
		result += "--------";
		return result;
	}
}