package org.ample.vml.vml4arch;

import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;

import org.eclipse.emf.ecore.EPackage;
import org.eclipse.jface.text.rules.IPartitionTokenScanner;
import org.openarchitectureware.xtext.AbstractLanguageUtilities;
import org.openarchitectureware.xtext.AbstractXtextEditorPlugin;
import org.openarchitectureware.xtext.XtextFile;
import org.openarchitectureware.xtext.parser.IXtextParser;

import org.ample.vml.vml4arch.parser.XtextParser;

public class Vml4archUtilities extends AbstractLanguageUtilities {

	// enforce eager registration of metamodel
	private static final EPackage EPACKAGE = org.ample.vml.vml4arch.MetaModelRegistration.getEPackage();
	
	@Override
	protected IXtextParser internalParse(InputStream inputStream) {
		return new XtextParser(inputStream);
	}

	public String getFileExtension() {
		return "vml4arch";
	}

	public EPackage getEPackage() {
		return EPACKAGE;
	}

	List<String> r = new ArrayList<String>();
	{
		r.add("pointcut");
		r.add("connect");
		r.add("remove");
		r.add("for");
		r.add("concern");
		r.add("merge");
		r.add("createPackage");
		r.add("variant");
		r.add("createConnector");
		r.add("setLiteralAttribute");
		r.add("order");
		r.add("features");
		r.add("feature");
		r.add("import");
		r.add("setDefaultAttribute");
		r.add("or");
		r.add("setAttribute");
		r.add("and");
		r.add("not");
		r.add("productconfig");
		r.add("setDefaultLiteralAttribute");
		r.add("core");
		r.add("connectPorts");
		r.add("createComponentInstance");
		r.add("pcref");
	}
	public List<String> allKeywords() {
		return r;
	}

	protected ClassLoader getClassLoader() {
		return this.getClass().getClassLoader();
	}

	public IPartitionTokenScanner getPartitionScanner() {
		return new GeneratedPartitionScanner();
	}

	@Override
	public AbstractXtextEditorPlugin getXtextEditorPlugin() {
		return Vml4archEditorPlugin.getDefault();
	}
	
	@Override
	public String getPackageForExtensions() {
		return "org::ample::vml::vml4arch";
	}
	
	public XtextFile getXtextFile() {
		return MetaModelRegistration.getXtextFile();
	}
	

}
