package org.ample.vml.vml4req;

import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;

import org.eclipse.emf.ecore.EPackage;
import org.eclipse.jface.text.rules.IPartitionTokenScanner;
import org.openarchitectureware.xtext.AbstractLanguageUtilities;
import org.openarchitectureware.xtext.AbstractXtextEditorPlugin;
import org.openarchitectureware.xtext.XtextFile;
import org.openarchitectureware.xtext.parser.IXtextParser;

import org.ample.vml.vml4req.parser.XtextParser;

public class Vml4reqUtilities extends AbstractLanguageUtilities {

	// enforce eager registration of metamodel
	private static final EPackage EPACKAGE = org.ample.vml.vml4req.MetaModelRegistration.getEPackage();
	
	@Override
	protected IXtextParser internalParse(InputStream inputStream) {
		return new XtextParser(inputStream);
	}

	public String getFileExtension() {
		return "vml4req";
	}

	public EPackage getEPackage() {
		return EPACKAGE;
	}

	List<String> r = new ArrayList<String>();
	{
		r.add("createInclude");
		r.add("pointcut");
		r.add("removeActivityModel");
		r.add("for");
		r.add("concern");
		r.add("removeUseCase");
		r.add("variant");
		r.add("createOutputPin");
		r.add("removeElement");
		r.add("order");
		r.add("createAction");
		r.add("connectPins");
		r.add("removeActor");
		r.add("features");
		r.add("atf");
		r.add("createDecisionNode");
		r.add("feature");
		r.add("import");
		r.add("connectActionsWithGuard");
		r.add("createAssociation");
		r.add("connectActivityElements");
		r.add("insertUseCase");
		r.add("createInherits");
		r.add("createActivityParameter");
		r.add("insertPackage");
		r.add("createExtends");
		r.add("connectActions");
		r.add("insertActor");
		r.add("trace");
		r.add("or");
		r.add("connectActionWithInitialNode");
		r.add("replaceActionByActivity");
		r.add("connectActionWithFinalNode");
		r.add("and");
		r.add("not");
		r.add("createObjectAction");
		r.add("removePackage");
		r.add("createActivityModel");
		r.add("productconfig");
		r.add("core");
		r.add("removeObjectAction");
		r.add("removeAction");
		r.add("pcref");
	}
	public List<String> allKeywords() {
		return r;
	}

	protected ClassLoader getClassLoader() {
		return this.getClass().getClassLoader();
	}

	public IPartitionTokenScanner getPartitionScanner() {
		return new GeneratedPartitionScanner();
	}

	@Override
	public AbstractXtextEditorPlugin getXtextEditorPlugin() {
		return Vml4reqEditorPlugin.getDefault();
	}
	
	@Override
	public String getPackageForExtensions() {
		return "org::ample::vml::vml4req";
	}
	
	public XtextFile getXtextFile() {
		return MetaModelRegistration.getXtextFile();
	}
	

}
