/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.ample.vmlLangInst;

import org.eclipse.emf.common.util.EList;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Tracing Aspect</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.ample.vmlLangInst.TracingAspect#getCreateOps <em>Create Ops</em>}</li>
 *   <li>{@link org.ample.vmlLangInst.TracingAspect#getRemoveOps <em>Remove Ops</em>}</li>
 *   <li>{@link org.ample.vmlLangInst.TracingAspect#getGetNameOp <em>Get Name Op</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.ample.vmlLangInst.VmlLangInstPackage#getTracingAspect()
 * @model annotation="comment value='The TracingAspect generates the tooling for trace-link generation for application engineering.'"
 * @generated
 */
public interface TracingAspect extends EvaluationAspect {

	/**
	 * Returns the value of the '<em><b>Create Ops</b></em>' attribute list.
	 * The list contents are of type {@link java.lang.String}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Create Ops</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Create Ops</em>' attribute list.
	 * @see org.ample.vmlLangInst.VmlLangInstPackage#getTracingAspect_CreateOps()
	 * @model annotation="comment value='A list of pointcuts over the xTend operations used to implement the actions. Every operation so matched is assumed to create a single model element and return it. The execution of a VML script will then generate a trace link from the current feature(s) to this newly generated model element.'"
	 * @generated
	 */
	EList<String> getCreateOps();

	/**
	 * Returns the value of the '<em><b>Remove Ops</b></em>' attribute list.
	 * The list contents are of type {@link java.lang.String}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Remove Ops</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Remove Ops</em>' attribute list.
	 * @see org.ample.vmlLangInst.VmlLangInstPackage#getTracingAspect_RemoveOps()
	 * @model annotation="comment value='A list of pointcuts over the xTend operations used to implement the actions. Every operation so matched is assumed to remove the element passed to it as the first parameter from the target model. The execution of a VML script will then generate a removal trace link from the current feature(s) to a representation of the traced model element.'"
	 * @generated
	 */
	EList<String> getRemoveOps();

	/**
	 * Returns the value of the '<em><b>Get Name Op</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Get Name Op</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Get Name Op</em>' attribute.
	 * @see #setGetNameOp(String)
	 * @see org.ample.vmlLangInst.VmlLangInstPackage#getTracingAspect_GetNameOp()
	 * @model annotation="comment value='Name of an operation that takes a model element and returns a string that can be used to identify this model element for tracing purposes.'"
	 * @generated
	 */
	String getGetNameOp();

	/**
	 * Sets the value of the '{@link org.ample.vmlLangInst.TracingAspect#getGetNameOp <em>Get Name Op</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Get Name Op</em>' attribute.
	 * @see #getGetNameOp()
	 * @generated
	 */
	void setGetNameOp(String value);
} // TracingAspect
