/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.ample.vmlLangInst.impl;

import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Collection;

import org.ample.vmlLangInst.LangInstModel;
import org.ample.vmlLangInst.TracingAspect;
import org.ample.vmlLangInst.VmlLangInstPackage;
import org.ample.vmlLangInst.util.EglHelper;
import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IFolder;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.FileLocator;
import org.eclipse.core.runtime.Path;
import org.eclipse.core.runtime.SubMonitor;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EDataTypeUniqueEList;
import org.eclipse.epsilon.egl.exceptions.EglRuntimeException;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Tracing Aspect</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.ample.vmlLangInst.impl.TracingAspectImpl#getCreateOps <em>Create Ops</em>}</li>
 *   <li>{@link org.ample.vmlLangInst.impl.TracingAspectImpl#getRemoveOps <em>Remove Ops</em>}</li>
 *   <li>{@link org.ample.vmlLangInst.impl.TracingAspectImpl#getGetNameOp <em>Get Name Op</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class TracingAspectImpl extends EObjectImpl implements TracingAspect {
	/**
	 * The cached value of the '{@link #getCreateOps() <em>Create Ops</em>}' attribute list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getCreateOps()
	 * @generated
	 * @ordered
	 */
	protected EList<String> createOps;
	/**
	 * The cached value of the '{@link #getRemoveOps() <em>Remove Ops</em>}' attribute list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getRemoveOps()
	 * @generated
	 * @ordered
	 */
	protected EList<String> removeOps;

	/**
	 * The default value of the '{@link #getGetNameOp() <em>Get Name Op</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGetNameOp()
	 * @generated
	 * @ordered
	 */
	protected static final String GET_NAME_OP_EDEFAULT = null;
	/**
	 * The cached value of the '{@link #getGetNameOp() <em>Get Name Op</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGetNameOp()
	 * @generated
	 * @ordered
	 */
	protected String getNameOp = GET_NAME_OP_EDEFAULT;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected TracingAspectImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return VmlLangInstPackage.Literals.TRACING_ASPECT;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public EList<String> getCreateOps() {
		if (createOps == null) {
			createOps = new EDataTypeUniqueEList<String>(String.class, this, VmlLangInstPackage.TRACING_ASPECT__CREATE_OPS);
		}
		return createOps;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public EList<String> getRemoveOps() {
		if (removeOps == null) {
			removeOps = new EDataTypeUniqueEList<String>(String.class, this, VmlLangInstPackage.TRACING_ASPECT__REMOVE_OPS);
		}
		return removeOps;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getGetNameOp() {
		return getNameOp;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setGetNameOp(String newGetNameOp) {
		String oldGetNameOp = getNameOp;
		getNameOp = newGetNameOp;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, VmlLangInstPackage.TRACING_ASPECT__GET_NAME_OP, oldGetNameOp, getNameOp));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public void generate(String projectName, SubMonitor progress) {
		// TODO: implement this method
		LangInstModel lim = (LangInstModel) eContainer();
		IProject generatorProject = ResourcesPlugin.getWorkspace().getRoot()
				.getProject(projectName + ".generator");

		try {
			// Generate tracing.ext
			URL eglURL = FileLocator
					.toFileURL(new URL(
							"platform:/plugin/org.ample.vmlstar.langinst.model/transformations/LIM2TracingEXT.egl"));
			IFolder compileFolder = generatorProject.getFolder(new Path(
					"/src/org/ample/vml/" + lim.getName()));
			IFile compileFile = compileFolder.getFile("tracing.ext");
			EglHelper.generateToFile(eglURL, lim, compileFile, progress
					.newChild(2));
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case VmlLangInstPackage.TRACING_ASPECT__CREATE_OPS:
				return getCreateOps();
			case VmlLangInstPackage.TRACING_ASPECT__REMOVE_OPS:
				return getRemoveOps();
			case VmlLangInstPackage.TRACING_ASPECT__GET_NAME_OP:
				return getGetNameOp();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case VmlLangInstPackage.TRACING_ASPECT__CREATE_OPS:
				getCreateOps().clear();
				getCreateOps().addAll((Collection<? extends String>)newValue);
				return;
			case VmlLangInstPackage.TRACING_ASPECT__REMOVE_OPS:
				getRemoveOps().clear();
				getRemoveOps().addAll((Collection<? extends String>)newValue);
				return;
			case VmlLangInstPackage.TRACING_ASPECT__GET_NAME_OP:
				setGetNameOp((String)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case VmlLangInstPackage.TRACING_ASPECT__CREATE_OPS:
				getCreateOps().clear();
				return;
			case VmlLangInstPackage.TRACING_ASPECT__REMOVE_OPS:
				getRemoveOps().clear();
				return;
			case VmlLangInstPackage.TRACING_ASPECT__GET_NAME_OP:
				setGetNameOp(GET_NAME_OP_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case VmlLangInstPackage.TRACING_ASPECT__CREATE_OPS:
				return createOps != null && !createOps.isEmpty();
			case VmlLangInstPackage.TRACING_ASPECT__REMOVE_OPS:
				return removeOps != null && !removeOps.isEmpty();
			case VmlLangInstPackage.TRACING_ASPECT__GET_NAME_OP:
				return GET_NAME_OP_EDEFAULT == null ? getNameOp != null : !GET_NAME_OP_EDEFAULT.equals(getNameOp);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (createOps: ");
		result.append(createOps);
		result.append(", removeOps: ");
		result.append(removeOps);
		result.append(", getNameOp: ");
		result.append(getNameOp);
		result.append(')');
		return result.toString();
	}

} // TracingAspectImpl
