package org.ample.vmlstar.util;

import java.net.URL;

/**
 * Extension to StandaloneSetup that allows us to register ecore files that are
 * on the classpath. Supposedly, this may cause trouble if these ecore files
 * reference other files (which ours don't at the moment).
 * 
 * @see http://www.openarchitectureware.org/forum/viewtopic.php?showtopic=6274
 * 
 * @author zschaler
 */
public class StandaloneSetup extends org.eclipse.mwe.emf.StandaloneSetup {
	public void addRegisterEcoreClasspathFile(String fileName) {
		URL file = this.getClass().getResource(fileName);
		if (file == null) {
			throw new RuntimeException("cannot find resource " + fileName
					+ " in classpath!");
		}
		try {
			addRegisterEcoreFile(file.toString());
		} catch (Exception e) {
			throw new RuntimeException(this.getClass().getName(), e);
		}
	}
}