package unl.vml4req;

import java.net.URL;
import java.util.ArrayList;
import java.util.List;

import org.eclipse.core.runtime.FileLocator;

import fct.ample.REVMLInterpretor.FMPUtils.ConfigFmpElement;
import fct.ample.REVMLInterpretor.FMPUtils.FmpElement;
import fct.ample.REVMLInterpretor.FMPUtils.ImportFmpConfigs;
import fct.ample.REVMLInterpretor.FMPUtils.ImportFmpFeatures;

public class FMPHelper {
	public static List<String> getAllFeatures(String sFMPUri) {
		try {
			// CANNOT ACTUALLY USE toFileURL from oAW scripts. However, we simply assume it's going to be a file URL.
			//String sGlobalFileName = FileLocator.toFileURL(new URL(sFMPUri)).getPath();
			String sGlobalFileName = new URL(sFMPUri).getPath();

			ImportFmpFeatures fmpFeatures = new ImportFmpFeatures(
					sGlobalFileName);
			List<String> lfResult = new ArrayList<String>(fmpFeatures
					.getFeatureModelElements().size());
			for (FmpElement feCurrent : fmpFeatures.getFeatureModelElements()) {
				lfResult.add(feCurrent.getProperties().getName());
			}

			return lfResult;
		} catch (Exception e) {
			e.printStackTrace();
		}

		return new ArrayList<String>();
	}

	public static List<String> getSelectedFeatures(String sFMPUri) {
		try {
			// CANNOT ACTUALLY USE toFileURL from oAW scripts. However, we simply assume it's going to be a file URL.
			//String sGlobalFileName = FileLocator.toFileURL(new URL(sFMPUri)).getPath();
			String sGlobalFileName = new URL(sFMPUri).getPath();

			ImportFmpConfigs fmpConfigs = new ImportFmpConfigs(sGlobalFileName);
			List<ConfigFmpElement> lCFEs = fmpConfigs.getFmpConfigurations()
					.get("Configuration 1");
			List<String> lfResult = new ArrayList<String>(lCFEs.size());
			for (ConfigFmpElement cfeCurrent : lCFEs) {
				if (cfeCurrent.getState().equals("selected")) {
					lfResult.add(cfeCurrent.getProperties().getName());
				}
			}
			return lfResult;
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}
}